import { BaseQuery } from './BaseQuery';
import { BaseMeasure } from './BaseMeasure';
type RollingWindow = {
    trailing?: string | 'unbounded';
    leading?: string | 'unbounded';
    offset?: 'start' | 'end';
};
export declare class CubeStoreQuery extends BaseQuery {
    newFilter(filter: any): any;
    convertTz(field: any): string;
    timeStampParam(): string;
    timeStampCast(value: any): string;
    timestampFormat(): string;
    dateTimeCast(value: any): string;
    subtractInterval(date: string, interval: string): string;
    addInterval(date: string, interval: string): string;
    timeGroupedColumn(granularity: string, dimension: string): string;
    neverUseSqlPlannerPreaggregation(): boolean;
    /**
     * Returns sql for source expression floored to timestamps aligned with
     * intervals relative to origin timestamp point.
     */
    dateBin(interval: string, source: string, origin: string): string;
    /**
     * The input interval with (possible) plural units, like "2 years", "3 months", "4 weeks", "5 days"...
     * will be converted to CubeStore (DataFusion) dialect.
     */
    private formatInterval;
    escapeColumnName(name: any): string;
    seriesSql(timeDimension: any): any;
    concatStringsSql(strings: string[]): string;
    unixTimestampSql(): string;
    wrapSegmentForDimensionSelect(sql: string): string;
    hllMerge(sql: any): string;
    hllCardinalityMerge(sql: string): string;
    hllCardinality(sql: string): string;
    castToString(sql: string): string;
    countDistinctApprox(sql: string): string;
    regularAndTimeSeriesRollupQuery(regularMeasures: BaseMeasure[], multipliedMeasures: BaseMeasure[], cumulativeMeasures: Array<[boolean, BaseMeasure]>, preAggregationForQuery: any): any;
    overTimeSeriesSelectRollup(cumulativeMeasures: any, otherMeasures: any, baseQuery: any, baseQueryAlias: any, timeDimension: any, preAggregationForQuery: any): string;
    toInterval(interval: any): string;
    maxRollingWindow(a: RollingWindow, b: RollingWindow): RollingWindow;
    overTimeSeriesForSelectRollup(cumulativeMeasures: any, otherMeasures: any, timeDimension: any, preAggregationForQuery: any): any;
}
export {};
//# sourceMappingURL=CubeStoreQuery.d.ts.map